Index: /code/branches/core7/src/modules/dodgerace/DodgeRaceCenterPoint.cc
===================================================================
--- /code/branches/core7/src/modules/dodgerace/DodgeRaceCenterPoint.cc	(revision 10571)
+++ /code/branches/core7/src/modules/dodgerace/DodgeRaceCenterPoint.cc	(revision 10572)
@@ -54,12 +54,4 @@
     }
 
-    void DodgeRaceCenterPoint::changedGametype()
-    {
-        SUPER(DodgeRaceCenterPoint, changedGametype);
-
-        // Check, whether it's still DodgeRace.
-        this->checkGametype();
-    }
-
     void DodgeRaceCenterPoint::checkGametype()
     {
Index: /code/branches/core7/src/modules/dodgerace/DodgeRaceCenterPoint.h
===================================================================
--- /code/branches/core7/src/modules/dodgerace/DodgeRaceCenterPoint.h	(revision 10571)
+++ /code/branches/core7/src/modules/dodgerace/DodgeRaceCenterPoint.h	(revision 10572)
@@ -52,5 +52,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
-            virtual void changedGametype(); //!< Is called when the gametype has changed.
         private:
             void checkGametype();
Index: /code/branches/core7/src/modules/invader/InvaderCenterPoint.cc
===================================================================
--- /code/branches/core7/src/modules/invader/InvaderCenterPoint.cc	(revision 10571)
+++ /code/branches/core7/src/modules/invader/InvaderCenterPoint.cc	(revision 10572)
@@ -54,12 +54,4 @@
     }
 
-    void InvaderCenterPoint::changedGametype()
-    {
-        SUPER(InvaderCenterPoint, changedGametype);
-
-        // Check, whether it's still Invader.
-        this->checkGametype();
-    }
-
     void InvaderCenterPoint::checkGametype()
     {
Index: /code/branches/core7/src/modules/invader/InvaderCenterPoint.h
===================================================================
--- /code/branches/core7/src/modules/invader/InvaderCenterPoint.h	(revision 10571)
+++ /code/branches/core7/src/modules/invader/InvaderCenterPoint.h	(revision 10572)
@@ -49,5 +49,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
-            virtual void changedGametype(); //!< Is called when the gametype has changed.
         private:
             void checkGametype();
Index: /code/branches/core7/src/modules/jump/JumpCenterpoint.cc
===================================================================
--- /code/branches/core7/src/modules/jump/JumpCenterpoint.cc	(revision 10571)
+++ /code/branches/core7/src/modules/jump/JumpCenterpoint.cc	(revision 10572)
@@ -80,11 +80,4 @@
     }
 
-    void JumpCenterpoint::changedGametype()
-    {
-        SUPER(JumpCenterpoint, changedGametype);
-
-        checkGametype();
-    }
-
     void JumpCenterpoint::checkGametype()
     {
Index: /code/branches/core7/src/modules/jump/JumpCenterpoint.h
===================================================================
--- /code/branches/core7/src/modules/jump/JumpCenterpoint.h	(revision 10571)
+++ /code/branches/core7/src/modules/jump/JumpCenterpoint.h	(revision 10572)
@@ -114,5 +114,4 @@
             virtual ~JumpCenterpoint() {}
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method to create a JumpCenterpoint through XML.
-            virtual void changedGametype();
             void setPlatformStaticTemplate(const std::string& balltemplate)
                 { this->platformStaticTemplate_ = balltemplate; }
Index: /code/branches/core7/src/modules/mini4dgame/Mini4DgameBoard.cc
===================================================================
--- /code/branches/core7/src/modules/mini4dgame/Mini4DgameBoard.cc	(revision 10571)
+++ /code/branches/core7/src/modules/mini4dgame/Mini4DgameBoard.cc	(revision 10572)
@@ -901,16 +901,4 @@
     /**
     @brief
-        Is called when the gametype has changed.
-    */
-    void Mini4DgameBoard::changedGametype()
-    {
-        SUPER(Mini4DgameBoard, changedGametype);
-
-        // Check, whether it's still Mini4Dgame.
-        this->checkGametype();
-    }
-
-    /**
-    @brief
         Checks whether the gametype is Mini4Dgame and if it is, sets its centerpoint.
     */
Index: /code/branches/core7/src/modules/mini4dgame/Mini4DgameBoard.h
===================================================================
--- /code/branches/core7/src/modules/mini4dgame/Mini4DgameBoard.h	(revision 10571)
+++ /code/branches/core7/src/modules/mini4dgame/Mini4DgameBoard.h	(revision 10572)
@@ -81,5 +81,4 @@
             Mini4DgameWinner getWinner();
 
-            void changedGametype();
             void checkGametype();
 
Index: /code/branches/core7/src/modules/pong/PongCenterpoint.cc
===================================================================
--- /code/branches/core7/src/modules/pong/PongCenterpoint.cc	(revision 10571)
+++ /code/branches/core7/src/modules/pong/PongCenterpoint.cc	(revision 10572)
@@ -80,16 +80,4 @@
     /**
     @brief
-        Is called when the gametype has changed.
-    */
-    void PongCenterpoint::changedGametype()
-    {
-        SUPER(PongCenterpoint, changedGametype);
-
-        // Check, whether it's still Pong.
-        this->checkGametype();
-    }
-
-    /**
-    @brief
         Checks whether the gametype is Pong and if it is, sets its centerpoint.
     */
Index: /code/branches/core7/src/modules/pong/PongCenterpoint.h
===================================================================
--- /code/branches/core7/src/modules/pong/PongCenterpoint.h	(revision 10571)
+++ /code/branches/core7/src/modules/pong/PongCenterpoint.h	(revision 10572)
@@ -126,6 +126,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method to create a PongCenterpoint through XML.
 
-            virtual void changedGametype(); //!< Is called when the gametype has changed.
-
             /**
             @brief Set the template for the ball. (e.g. to attach the model of the ball, but also to attach an EventListener to it to detect, when it hits the boundaries, and e.g. display some ParticleEffets, when it does.)
Index: /code/branches/core7/src/modules/tetris/TetrisCenterpoint.cc
===================================================================
--- /code/branches/core7/src/modules/tetris/TetrisCenterpoint.cc	(revision 10571)
+++ /code/branches/core7/src/modules/tetris/TetrisCenterpoint.cc	(revision 10572)
@@ -80,16 +80,4 @@
     /**
     @brief
-        Is called when the gametype has changed.
-    */
-    void TetrisCenterpoint::changedGametype()
-    {
-        SUPER(TetrisCenterpoint, changedGametype);
-
-        // Check, whether it's still Tetris.
-        this->checkGametype();
-    }
-
-    /**
-    @brief
         Checks whether the gametype is Tetris and if it is, sets its centerpoint.
     */
Index: /code/branches/core7/src/modules/tetris/TetrisCenterpoint.h
===================================================================
--- /code/branches/core7/src/modules/tetris/TetrisCenterpoint.h	(revision 10571)
+++ /code/branches/core7/src/modules/tetris/TetrisCenterpoint.h	(revision 10572)
@@ -64,6 +64,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method to create a TetrisCenterpoint through XML.
 
-            virtual void changedGametype(); //!< Is called when the gametype has changed.
-            
             /**
             @brief Set the width of the playing field.
Index: /code/branches/core7/src/modules/towerdefense/TowerDefenseCenterpoint.cc
===================================================================
--- /code/branches/core7/src/modules/towerdefense/TowerDefenseCenterpoint.cc	(revision 10571)
+++ /code/branches/core7/src/modules/towerdefense/TowerDefenseCenterpoint.cc	(revision 10572)
@@ -84,16 +84,4 @@
     /**
     @brief
-        Is called when the gametype has changed.
-    */
-    void TowerDefenseCenterpoint::changedGametype()
-    {
-        SUPER(TowerDefenseCenterpoint, changedGametype);
-
-        // Check, whether it's still TowerDefense.
-        this->checkGametype();
-    }
-
-    /**
-    @brief
         Checks whether the gametype is TowerDefense and if it is, sets its centerpoint.
     */
Index: /code/branches/core7/src/modules/towerdefense/TowerDefenseCenterpoint.h
===================================================================
--- /code/branches/core7/src/modules/towerdefense/TowerDefenseCenterpoint.h	(revision 10571)
+++ /code/branches/core7/src/modules/towerdefense/TowerDefenseCenterpoint.h	(revision 10572)
@@ -53,5 +53,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void changedGametype();
 
             /**