Index: branches/cleanup/src/lib/util/Makefile.am
===================================================================
--- branches/cleanup/src/lib/util/Makefile.am	(revision 10574)
+++ branches/cleanup/src/lib/util/Makefile.am	(revision 10575)
@@ -29,5 +29,5 @@
 		filesys/net_link.cc \
 		\
-		threading.cc \
+		threads/thread.cc \
 		timer.cc
 
@@ -63,5 +63,9 @@
 		filesys/net_link.h \
 		\
-		threading.h \
+		threads/threading.h \
+		threads/thread.h \
+		threads/mutex.h \
+		threads/mutex_locker.h \
+		\
 		timer.h \
 		\
Index: branches/cleanup/src/lib/util/debug_buffer.cc
===================================================================
--- branches/cleanup/src/lib/util/debug_buffer.cc	(revision 10574)
+++ branches/cleanup/src/lib/util/debug_buffer.cc	(revision 10575)
@@ -20,5 +20,5 @@
 #include "debug.h"
 #include "compiler.h"
-#include "threading.h"
+#include "threads/threading.h"
 
 /**
Index: branches/cleanup/src/lib/util/filesys/net_link.h
===================================================================
--- branches/cleanup/src/lib/util/filesys/net_link.h	(revision 10574)
+++ branches/cleanup/src/lib/util/filesys/net_link.h	(revision 10575)
@@ -19,5 +19,5 @@
 #include <list>
 
-#include "threading.h"
+#include "threads/threading.h"
 
 //! NetLink is a File and Link executer for Internet Links
Index: branches/cleanup/src/lib/util/threading.cc
===================================================================
--- branches/cleanup/src/lib/util/threading.cc	(revision 10574)
+++ 	(revision )
@@ -1,42 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: ...
-   co-programmer: ...
-*/
-
-//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
-
-#include "threading.h"
-
-
-
-namespace OrxThread
-{
-
-/**
- * standard constructor
- * @todo this constructor is not jet implemented - do it
-*/
-// Thread::Thread()
-// {
-// }
-
-
-/**
- * standard deconstructor
-*/
-// Thread::~Thread()
-// {
-//   // delete what has to be deleted here
-// }
-
-}
Index: branches/cleanup/src/lib/util/threading.h
===================================================================
--- branches/cleanup/src/lib/util/threading.h	(revision 10574)
+++ 	(revision )
@@ -1,65 +1,0 @@
-/*!
- * @file threading.h
- * @brief Definition of Thread Classes.
- *
- * These are mainly Classes, that are used for wrapping around SDL_thread
-*/
-
-#ifndef _THREADING_H
-#define _THREADING_H
-
-#ifdef HAVE_SDL_H
- #include <SDL_thread.h>
-#else
- #include <SDL/SDL_thread.h>
-#endif
-
-namespace OrxThread
-{
-  //! A class for Wrapping Threads
-  class Thread
-  {
-  public:
-    Thread(int (*fn)(void *), void *data) { this->thread = SDL_CreateThread(fn, data); };
-    virtual ~Thread() { SDL_KillThread(this->thread); }
-    void exit ( int returnCode = 0 );
-    bool isFinished () const;
-    bool isRunning () const;
-    void wait() { SDL_WaitThread(this->thread, NULL); };
-
-    void start();
-    void terminate();
-
-
-  private:
-    SDL_Thread* thread;
-
-  };
-
-  class Mutex
-  {
-  public:
-    Mutex() {  this->mutex = SDL_CreateMutex(); };
-    ~Mutex() { SDL_DestroyMutex(this->mutex); }
-
-    void lock() { SDL_mutexP(mutex); };
-    void unlock() { SDL_mutexV(mutex); };
-
-    SDL_mutex* getMutex() const { return this->mutex; };
-  private:
-    SDL_mutex* mutex;
-  };
-
-  //! A Class that locks a Mutex within its scope
-  class MutexLock
-  {
-  public:
-    //! Locks the Mutex mutex in this Scope.
-    MutexLock(Mutex* mutex) { SDL_mutexP(mutex->getMutex()); this->mutex = mutex; };
-    ~MutexLock() { SDL_mutexV(mutex->getMutex()); };
-  private:
-    Mutex* mutex;         //!< The Mutex to lock.
-  };
-}
-
-#endif /* _THREADING_H */
Index: branches/cleanup/src/lib/util/threads/thread.cc
===================================================================
--- branches/cleanup/src/lib/util/threads/thread.cc	(revision 10575)
+++ branches/cleanup/src/lib/util/threads/thread.cc	(revision 10575)
@@ -0,0 +1,42 @@
+/*
+    orxonox - the future of 3D-vertical-scrollers
+
+    Copyright (C) 2004 orx
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2, or (at your option)
+    any later version.
+
+### File Specific:
+    main-programmer: ...
+    co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "threading.h"
+
+
+
+    namespace OrxThread
+{
+
+/**
+   * standard constructor
+   * @todo this constructor is not jet implemented - do it
+ */
+// Thread::Thread()
+// {
+// }
+
+
+/**
+   * standard deconstructor
+ */
+// Thread::~Thread()
+// {
+//   // delete what has to be deleted here
+// }
+
+}
Index: branches/cleanup/src/lib/util/threads/thread.h
===================================================================
--- branches/cleanup/src/lib/util/threads/thread.h	(revision 10575)
+++ branches/cleanup/src/lib/util/threads/thread.h	(revision 10575)
@@ -0,0 +1,32 @@
+#ifndef __THREAD_H__
+#define __THREAD_H__
+
+#ifdef HAVE_SDL_H
+#include <SDL_thread.h>
+#else
+#include <SDL/SDL_thread.h>
+#endif
+
+namespace OrxThread
+{
+  //! A class for Wrapping Threads
+  class Thread
+  {
+    public:
+      Thread(int (*fn)(void *), void *data) { this->thread = SDL_CreateThread(fn, data); };
+      virtual ~Thread() { SDL_KillThread(this->thread); }
+      void exit ( int returnCode = 0 );
+      bool isFinished () const;
+      bool isRunning () const;
+      void wait() { SDL_WaitThread(this->thread, NULL); };
+
+      void start();
+      void terminate();
+
+
+    private:
+      SDL_Thread* thread;
+
+  };
+
+#endif /* __THREAD_H__ */