Index: branches/cleanup/src/lib/sound/ogg_player.cc
===================================================================
--- branches/cleanup/src/lib/sound/ogg_player.cc	(revision 10576)
+++ branches/cleanup/src/lib/sound/ogg_player.cc	(revision 10577)
@@ -79,5 +79,5 @@
   bool OggPlayer::open(const std::string& fileName)
   {
-    OrxThread::MutexLock musicLock(&this->musicMutex);
+    OrxThread::MutexLocker musicLock(&this->musicMutex);
     // release old Ogg-File (if loaded)
     if (this->state & OggPlayer::FileOpened)
@@ -212,5 +212,5 @@
     if (this->state & OggPlayer::FileOpened)
     {
-      OrxThread::MutexLock musicLock(&this->musicMutex);
+      OrxThread::MutexLocker musicLock(&this->musicMutex);
       ov_time_seek(&this->oggStream, timeCode);
     }
@@ -263,5 +263,5 @@
     {
       {
-        OrxThread::MutexLock musicLock(&ogg->musicMutex);
+        OrxThread::MutexLocker musicLock(&ogg->musicMutex);
         ogg->update();
       }
@@ -286,5 +286,5 @@
     this->state |= OggPlayer::Playing;
 
-    OrxThread::MutexLock musicLock(&this->musicMutex);
+    OrxThread::MutexLocker musicLock(&this->musicMutex);
     if(!this->stream(this->buffers[0]) || !this->stream(this->buffers[1]))
     {
Index: branches/cleanup/src/lib/sound/ogg_player.h
===================================================================
--- branches/cleanup/src/lib/sound/ogg_player.h	(revision 10576)
+++ branches/cleanup/src/lib/sound/ogg_player.h	(revision 10577)
@@ -13,5 +13,5 @@
 #include <ogg/ogg.h>
 #include <vorbis/vorbisfile.h>
-#include "util/threads/threading.h"
+#include "util/threads/mutex_locker.h"
 
 struct File;
Index: branches/cleanup/src/lib/util/debug_buffer.cc
===================================================================
--- branches/cleanup/src/lib/util/debug_buffer.cc	(revision 10576)
+++ branches/cleanup/src/lib/util/debug_buffer.cc	(revision 10577)
@@ -20,5 +20,5 @@
 #include "debug.h"
 #include "compiler.h"
-#include "threads/threading.h"
+#include "threads/mutex_locker.h"
 
 /**
@@ -64,5 +64,5 @@
   static OrxThread::Mutex DebugBuffer__bufferMutex;
 
-  OrxThread::MutexLock bufferLock(&DebugBuffer__bufferMutex);
+  OrxThread::MutexLocker bufferLock(&DebugBuffer__bufferMutex);
 
   va_list arguments;
Index: branches/cleanup/src/lib/util/filesys/net_link.cc
===================================================================
--- branches/cleanup/src/lib/util/filesys/net_link.cc	(revision 10576)
+++ branches/cleanup/src/lib/util/filesys/net_link.cc	(revision 10577)
@@ -17,4 +17,5 @@
 #include "debug.h"
 
+#include "threads/mutex_locker.h"
 
 #ifdef __OSX__
@@ -45,5 +46,5 @@
 int NetLink::openupInBrowser(void* url)
 {
-  OrxThread::MutexLock lock(&NetLink::_mutex);
+  OrxThread::MutexLocker lock(&NetLink::_mutex);
 
   std::string URL = *(std::string*)url;
@@ -69,5 +70,5 @@
 void NetLink::setDefaultBrowser(const std::string& browserName)
 {
-  OrxThread::MutexLock lock(&NetLink::_mutex);
+  OrxThread::MutexLocker lock(&NetLink::_mutex);
   NetLink::_defaultBrowser = browserName;
 }
Index: branches/cleanup/src/lib/util/filesys/net_link.h
===================================================================
--- branches/cleanup/src/lib/util/filesys/net_link.h	(revision 10576)
+++ branches/cleanup/src/lib/util/filesys/net_link.h	(revision 10577)
@@ -19,5 +19,5 @@
 #include <list>
 
-#include "threads/threading.h"
+#include "threads/mutex.h"
 
 //! NetLink is a File and Link executer for Internet Links
Index: branches/cleanup/src/lib/util/threads/mutex_locker.h
===================================================================
--- branches/cleanup/src/lib/util/threads/mutex_locker.h	(revision 10576)
+++ branches/cleanup/src/lib/util/threads/mutex_locker.h	(revision 10577)
@@ -8,10 +8,10 @@
 
   //! A Class that locks a Mutex within its scope
-  class MutexLock
+  class MutexLocker
   {
   public:
     //! Locks the Mutex mutex in this Scope.
-    MutexLock(Mutex* mutex) { SDL_mutexP(mutex->getMutex()); this->mutex = mutex; };
-    ~MutexLock() { SDL_mutexV(mutex->getMutex()); };
+    MutexLocker(Mutex* mutex) { SDL_mutexP(mutex->getMutex()); this->mutex = mutex; };
+    ~MutexLocker() { SDL_mutexV(mutex->getMutex()); };
   private:
     Mutex* mutex;         //!< The Mutex to lock.