Index: /branches/cleanup/src/world_entities/projectiles/swarm_projectile.cc
===================================================================
--- /branches/cleanup/src/world_entities/projectiles/swarm_projectile.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/projectiles/swarm_projectile.cc	(revision 10579)
@@ -39,7 +39,5 @@
 SwarmProjectile::SwarmProjectile () : Projectile()
 {
-
-/*  this->loadModel("models/projectiles/orx-rocket.obj", 0.5);*/
-  this->loadModel("models/projectiles/swarm_projectile.obj", .25); // no double rescale (see draw())
+  this->loadModel("models/projectiles/swarm_projectile.obj", .333); // no double rescale (see draw())
   this->loadExplosionSound("sounds/explosions/explosion_4.wav");
 
Index: /branches/cleanup/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/cleanup/src/world_entities/space_ships/space_ship.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/space_ships/space_ship.cc	(revision 10579)
@@ -616,5 +616,5 @@
   {
     this->bRight = event.bPressed;
-    printf("ShipCoors: %f , %f, %f \n", this->getAbsCoor().x, this->getAbsCoor().y, this->getAbsCoor().z);
+//     printf("ShipCoors: %f , %f, %f \n", this->getAbsCoor().x, this->getAbsCoor().y, this->getAbsCoor().z);
   }
   else if( event.type == KeyMapper::PEV_FORWARD)
Index: /branches/cleanup/src/world_entities/weapons/acid_launcher.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/acid_launcher.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/acid_launcher.cc	(revision 10579)
@@ -103,5 +103,5 @@
   this->setActionSound(WA_SHOOT, "sounds/explosions/explosion_1.wav");
   this->setActionSound(WA_ACTIVATE, "sounds/voices/rockets.wav");
-  this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
+//   this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
 
 }
Index: /branches/cleanup/src/world_entities/weapons/aiming_turret.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/aiming_turret.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/aiming_turret.cc	(revision 10579)
@@ -100,5 +100,5 @@
   this->setActionSound(WA_SHOOT, "sounds/explosions/explosion_3.wav");
   this->setActionSound(WA_ACTIVATE, "sounds/voices/rockets.wav");
-  this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
+//   this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
 
 }
Index: /branches/cleanup/src/world_entities/weapons/boomerang_gun.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/boomerang_gun.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/boomerang_gun.cc	(revision 10579)
@@ -96,5 +96,5 @@
   this->setActionSound(WA_SHOOT, "sounds/explosions/explosion_3.wav");
   this->setActionSound(WA_ACTIVATE, "sounds/voices/rockets.wav");
-  this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
+//   this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
 
 }
Index: /branches/cleanup/src/world_entities/weapons/heavy_blaster.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/heavy_blaster.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/heavy_blaster.cc	(revision 10579)
@@ -1,2 +1,18 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004-2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Marc Schaerrer, Nicolas Schlumberger
+   co-programmer:
+
+*/
+
 #include "heavy_blaster.h"
 #include "world_entities/projectiles/projectile.h"
Index: /branches/cleanup/src/world_entities/weapons/light_blaster.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/light_blaster.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/light_blaster.cc	(revision 10579)
@@ -1,2 +1,18 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004-2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Marc Schaerrer, Nicolas Schlumberger
+   co-programmer:
+
+*/
+
 #include "light_blaster.h"
 #include "world_entities/projectiles/projectile.h"
Index: /branches/cleanup/src/world_entities/weapons/medium_blaster.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/medium_blaster.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/medium_blaster.cc	(revision 10579)
@@ -1,2 +1,18 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004-2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Marc Schaerrer, Nicolas Schlumberger
+   co-programmer:
+
+*/
+
 #include "medium_blaster.h"
 #include "world_entities/projectiles/projectile.h"
Index: /branches/cleanup/src/world_entities/weapons/spike_launcher.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/spike_launcher.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/spike_launcher.cc	(revision 10579)
@@ -10,5 +10,5 @@
 
    ### File Specific
-   main-programmer: Marc Schaerrer
+   main-programmer: Marc Schaerrer, Nicolas Schlumberger
    co-programmer:
 */
Index: /branches/cleanup/src/world_entities/weapons/spike_thrower.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/spike_thrower.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/spike_thrower.cc	(revision 10579)
@@ -10,5 +10,5 @@
 
    ### File Specific
-   main-programmer: Marc Schaerrer
+   main-programmer: Marc Schaerrer, Nicolas Schlumberger
    co-programmer:
 */
@@ -105,5 +105,5 @@
   this->setActionSound(WA_SHOOT, "sounds/explosions/explosion_1.wav");
   this->setActionSound(WA_ACTIVATE, "sounds/voices/rockets.wav");
-  this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
+//   this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
 
 }
Index: /branches/cleanup/src/world_entities/weapons/swarm_launcher.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/swarm_launcher.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/swarm_launcher.cc	(revision 10579)
@@ -105,5 +105,5 @@
   this->setActionSound(WA_SHOOT, "sounds/explosions/explosion_1.wav");
   this->setActionSound(WA_ACTIVATE, "sounds/voices/rockets.wav");
-  this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
+//   this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
 
 }
Index: /branches/cleanup/src/world_entities/weapons/targeting_turret.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/targeting_turret.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/targeting_turret.cc	(revision 10579)
@@ -94,5 +94,5 @@
   this->setActionSound(WA_SHOOT, "sounds/explosions/explosion_3.wav");
   this->setActionSound(WA_ACTIVATE, "sounds/voices/rockets.wav");
-  this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
+//   this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
 }
 
Index: /branches/cleanup/src/world_entities/weapons/turret.cc
===================================================================
--- /branches/cleanup/src/world_entities/weapons/turret.cc	(revision 10578)
+++ /branches/cleanup/src/world_entities/weapons/turret.cc	(revision 10579)
@@ -95,5 +95,5 @@
   this->setActionSound(WA_SHOOT, "sounds/explosions/explosion_3.wav");
   this->setActionSound(WA_ACTIVATE, "sounds/voices/rockets.wav");
-  this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
+//   this->setActionSound(WA_RELOAD, "sounds/voices/reload.wav");
 
 }