Index: branches/cleanup/src/world_entities/camera.cc
===================================================================
--- branches/cleanup/src/world_entities/camera.cc	(revision 10585)
+++ branches/cleanup/src/world_entities/camera.cc	(revision 10588)
@@ -102,9 +102,9 @@
 
   //add to track
-/*  if(this->entityTrack)
+  if(this->entityTrack)
    {
     this->setParent(this->entityTrack->getTrackNode());
     //this->setRelCoor(0,0,0);
-   }*/
+   }
 }
 
@@ -227,5 +227,5 @@
   {
     //PRINTF(0)("tickytackytucky\n");
-/*    this->entityTrack->tick(dt);*/
+    this->entityTrack->tick(dt);
     //this->setAbsCoor(this->entityTrack->getTrackNode()->getAbsCoor());
   } 
@@ -240,6 +240,6 @@
 void Camera::draw() const
 {
-/*  if( this->entityTrack != NULL && this->isDrawTrack())
-    this->entityTrack->drawGraph();*/
+  if( this->entityTrack != NULL && this->isDrawTrack())
+    this->entityTrack->drawGraph();
 }
 
Index: branches/cleanup/src/world_entities/npcs/npc.cc
===================================================================
--- branches/cleanup/src/world_entities/npcs/npc.cc	(revision 10585)
+++ branches/cleanup/src/world_entities/npcs/npc.cc	(revision 10588)
@@ -152,5 +152,5 @@
   if( this->entityTrack)
   {
-/*      this->setParent(this->entityTrack->getTrackNode());*/
+      this->setParent(this->entityTrack->getTrackNode());
       this->setRelCoor(0,0,0);
   }
@@ -426,6 +426,6 @@
   this->bFire = false;
 
-//  if(this->entityTrack)
-//     this->entityTrack->tick(dt);
+ if(this->entityTrack)
+    this->entityTrack->tick(dt);
 
 }
@@ -433,6 +433,6 @@
 void NPC::draw() const
 {
-//  if( this->entityTrack != NULL && this->isDrawTrack())
-//   this->entityTrack->drawGraph();
+ if( this->entityTrack != NULL && this->isDrawTrack())
+  this->entityTrack->drawGraph();
 
  WorldEntity::draw();
Index: branches/cleanup/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/cleanup/src/world_entities/space_ships/space_ship.cc	(revision 10585)
+++ branches/cleanup/src/world_entities/space_ships/space_ship.cc	(revision 10588)
@@ -493,6 +493,6 @@
 void SpaceShip::draw () const
 {
-//   if( this->entityTrack != NULL && this->isDrawTrack())
-//     this->entityTrack->drawGraph();
+  if( this->entityTrack != NULL && this->isDrawTrack())
+    this->entityTrack->drawGraph();
 
   WorldEntity::draw();
@@ -550,6 +550,6 @@
 
   // Tracktick
-//   if(this->entityTrack)
-//     this->entityTrack->tick(time);
+  if(this->entityTrack)
+    this->entityTrack->tick(time);
 
 
@@ -867,6 +867,6 @@
         this->isTravelDistanceInit = false;
 
-//         if(this->entityTrack)
-//            this->travelNode->setParent(this->entityTrack->getTrackNode());
+        if(this->entityTrack)
+           this->travelNode->setParent(this->entityTrack->getTrackNode());
 
         this->setParent(this->travelNode);
Index: branches/cleanup/src/world_entities/test_entity.cc
===================================================================
--- branches/cleanup/src/world_entities/test_entity.cc	(revision 10585)
+++ branches/cleanup/src/world_entities/test_entity.cc	(revision 10588)
@@ -86,6 +86,6 @@
 
  //add to track
-//   if(this->entityTrack)
-//     this->setParent(this->entityTrack->getTrackNode());
+  if(this->entityTrack)
+    this->setParent(this->entityTrack->getTrackNode());
 
 }
@@ -138,6 +138,6 @@
 
 
-// if( this->entityTrack != NULL)
-//     this->entityTrack->drawGraph();
+if( this->entityTrack != NULL)
+    this->entityTrack->drawGraph();
 
 }
@@ -148,6 +148,6 @@
 void TestEntity::tick (float time)
 {
-//  if(this->entityTrack)
-//     this->entityTrack->tick(time);
+ if(this->entityTrack)
+    this->entityTrack->tick(time);
 
 
Index: branches/cleanup/src/world_entities/world_entity.cc
===================================================================
--- branches/cleanup/src/world_entities/world_entity.cc	(revision 10585)
+++ branches/cleanup/src/world_entities/world_entity.cc	(revision 10588)
@@ -185,7 +185,7 @@
 {
   // The problem we have is most likely here. The track should be constructed WITH the XML-Code
-/*  this->entityTrack = new Track(root);
+  this->entityTrack = new Track(root);
   this->setParent(this->entityTrack->getTrackNode());
-  this->entityTrack->getTrackNode()->setParentMode(PNODE_ALL);*/
+  this->entityTrack->getTrackNode()->setParentMode(PNODE_ALL);
   /*LOAD_PARAM_START_CYCLE(root, element);
   {
@@ -200,6 +200,6 @@
 void WorldEntity::pauseTrack(bool stop)
 {
-/*     if(this->entityTrack)
-       this->entityTrack->pauseTrack(stop);*/ 
+     if(this->entityTrack)
+       this->entityTrack->pauseTrack(stop);
 }
 