Index: /branches/cleanup/src/lib/math/curve.h
===================================================================
--- /branches/cleanup/src/lib/math/curve.h	(revision 10588)
+++ /branches/cleanup/src/lib/math/curve.h	(revision 10589)
@@ -102,13 +102,3 @@
 
 
-//! B-Spline
-/**
-   class to handle b-spline in 3d space
-*/
-class BSplieCurve : public Curve
-{
-
-
-};
-
 #endif /* _CURVE_H */
Index: anches/cleanup/src/util/track/pilot_node.cc
===================================================================
--- /branches/cleanup/src/util/track/pilot_node.cc	(revision 10588)
+++ 	(revision )
@@ -1,126 +1,0 @@
-
-
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: Patrick Boenzli
-   co-programmer: ...
-
-   bensch: added comments
-*/
-
-
-#include "pilot_node.h"
-#include "event.h"
-#include "key_mapper.h"
-
-
-ObjectListDefinition(PilotNode);
-/**
- *  standard constructor
-*/
-PilotNode::PilotNode ()
-{
-  this->registerObject(this, PilotNode::_objectList);
-   this->setName("PilotNode");
-
-   travelSpeed = 30.0;
-   velocity = new Vector();
-   bUp = bDown = bLeft = bRight = false;
-}
-
-/**
- *  standard deconstructor
-*/
-PilotNode::~PilotNode ()
-{
-
-}
-
-/**
-  *  ticks the node
-  * @param time the time about whitch to tick                                           \
-*/
-void PilotNode::tick(float time)
-{
-  this->move(time);
-}
-
-
-/**
- *  action if player moves
- * @param time the timeslice since the last frame
-*/
-void PilotNode::move (float time)
-{
-  Vector accel(0.0, 0.0, 0.0);
-  /* FIXME: calculating the direction and orthDirection every timeSlice is redundant! save it somewhere */
-  /* calculate the direction in which the craft is heading  */
-  //Vector direction (1.0, 0.0, 0.0);
-  //direction = this->absDirection.apply (direction);
-  //Vector orthDirection (0.0, 0.0, 1.0);
-  //orthDirection = orthDirection.cross (direction);
-
-   Quaternion q = this->getAbsDir();
-   Vector direction(1,0,0);
-   direction = q.apply(direction);
-
-
-
-   Vector orthDirection(0,0,1);
-   orthDirection = q.apply(orthDirection);
-
-   if( this->bUp)
-     accel = accel+(direction*acceleration);
-   if( this->bDown)
-     accel = accel -(direction*acceleration);
-   if( this->bLeft)
-     accel = accel - (orthDirection*acceleration);
-   if( this->bRight)
-     accel = accel + (orthDirection*acceleration);
-
-   Vector move = accel * time;
-   this->shiftCoor (move);
-
-   Quaternion q1(-M_PI/4 * this->roll/40000.0, Vector(0,0,1));
-   Quaternion q2(-M_PI/4 * this->pitch/30000.0, Vector(0,1,0));
-   //this->shiftDir(q1*q2);
-   this->shiftDir(q1*q2);
-}
-
-/**
- *  handles events
- * @param event the event that occured
-*/
-void PilotNode::process( const Event &event)
-{
-  if( event.type == KeyMapper::PEV_FORWARD)
-    {
-      this->bUp = event.bPressed;
-    }
-  else if( event.type == KeyMapper::PEV_BACKWARD)
-    {
-      this->bDown = event.bPressed;
-    }
-  else if( event.type == KeyMapper::PEV_RIGHT)
-    {
-      this->bRight= event.bPressed;
-    }
-  else if( event.type == KeyMapper::PEV_LEFT)
-    {
-      this->bLeft = event.bPressed;
-    }
-  else if( event.type == EV_MOUSE_MOTION)
-    {
-      this->pitch = event.x - 400;
-      this->roll = event.y - 300;
-    }
-}
Index: anches/cleanup/src/util/track/pilot_node.h
===================================================================
--- /branches/cleanup/src/util/track/pilot_node.h	(revision 10588)
+++ 	(revision )
@@ -1,46 +1,0 @@
-/*!
- * @file pilot_node.h
-  *  Definition of a PilotNode
-*/
-
-
-#ifndef _PILOT_NODE_H
-#define _PILOT_NODE_H
-
-#include "world_entity.h"
-#include "event_listener.h"
-
-class Event;
-
-//! The PilotNode is a node that enables the is driven by the Mouse
-class PilotNode : public WorldEntity, public EventListener {
-  ObjectListDeclaration(PilotNode);
-
- public:
-  PilotNode ();
-  virtual ~PilotNode ();
-
-  virtual void tick(float time);
-
-  virtual void process(const Event &event);
-
- private:
-  void move(float time);
-
- private:
-  bool        bUp;            //!< up button pressed.
-  bool        bDown;          //!< down button pressed.
-  bool        bLeft;          //!< left button pressed.
-  bool        bRight;         //!< right button pressed.
-
-  int         pitch;          //!< the pitch of the node
-  int         roll;           //!< the roll of the node
-
-  Vector*     velocity;       //!< the velocity of the player.
-  float       travelSpeed;    //!< the current speed of the player (to make soft movement)
-  float       acceleration;   //!< the acceleration of the player.
-
-
-};
-
-#endif /* _PILOT_NODE_H */